gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.Gesture

Contents

- Exported types
- Methods
  - getBoundingBox
  - getBoundingBoxCenter
  - getDevice
  - getGroup
  - getLastEvent
  - getLastUpdatedSequence
  - getPoint
  - getSequenceState
  - getSequences
  - getWindow
  - group
  - handlesSequence
  - isActive
  - isGroupedWith
  - isRecognized
  - setSequenceState
  - setState
  - setWindow
  - ungroup
- Properties
  - nPoints
  - window
- Signals
  - begin
  - cancel
  - end
  - sequenceStateChanged
  - update

Description

`Gesture` is the base object for gesture recognition, although this object is quite generalized to serve as a base for multi-touch gestures, it is suitable to implement single-touch and pointer-based gestures (using the special `Nothing` `EventSequence` value for these).

The number of touches that a `Gesture` need to be recognized is controlled by the Gesture:nPoints property, if a gesture is keeping track of less or more than that number of sequences, it won't check wether the gesture is recognized.

As soon as the gesture has the expected number of touches, the gesture will run the `Gesture`::`check` signal regularly on input events until the gesture is recognized, the criteria to consider a gesture as "recognized" is left to `Gesture` subclasses.

A recognized gesture will then emit the following signals: * Gesture::begin when the gesture is recognized. * A number of Gesture::update, whenever an input event is processed. * Gesture::end when the gesture is no longer recognized.

## Event propagation

In order to receive events, a gesture needs to either set a propagation phase through `eventControllerSetPropagationPhase`, or feed those manually through `eventControllerHandleEvent`.

In the capture phase, events are propagated from the toplevel down to the target widget, and gestures that are attached to containers above the widget get a chance to interact with the event before it reaches the target.

After the capture phase, GTK+ emits the traditional Widget::buttonPressEvent, Widget::buttonReleaseEvent, Widget::touchEvent, etc signals. Gestures with the `PropagationPhaseTarget` phase are fed events from the default Widget::event handlers.

In the bubble phase, events are propagated up from the target widget to the toplevel, and gestures that are attached to containers above the widget get a chance to interact with events that have not been handled yet.

## States of a sequence # {`touch`-sequence-states}

Whenever input interaction happens, a single event may trigger a cascade of `GtkGestures`, both across the parents of the widget receiving the event and in parallel within an individual widget. It is a responsibility of the widgets using those gestures to set the state of touch sequences accordingly in order to enable cooperation of gestures around the `GdkEventSequences` triggering those.

Within a widget, gestures can be grouped through `gestureGroup`, grouped gestures synchronize the state of sequences, so calling `gestureSetSequenceState` on one will effectively propagate the state throughout the group.

By default, all sequences start out in the `GTK_EVENT_SEQUENCE_NONE` state, sequences in this state trigger the gesture event handler, but event propagation will continue unstopped by gestures.

If a sequence enters into the `GTK_EVENT_SEQUENCE_DENIED` state, the gesture group will effectively ignore the sequence, letting events go unstopped through the gesture, but the "slot" will still remain occupied while the touch is active.

If a sequence enters in the `GTK_EVENT_SEQUENCE_CLAIMED` state, the gesture group will grab all interaction on the sequence, by: * Setting the same sequence to `GTK_EVENT_SEQUENCE_DENIED` on every other gesture group within the widget, and every gesture on parent widgets in the propagation chain. * calling Gesture::cancel on every gesture in widgets underneath in the propagation chain. * Stopping event propagation after the gesture group handles the event.

Note: if a sequence is set early to `GTK_EVENT_SEQUENCE_CLAIMED` on `GDK_TOUCH_BEGIN`/`GDK_BUTTON_PRESS` (so those events are captured before reaching the event widget, this implies `GTK_PHASE_CAPTURE`), one similar event will emulated if the sequence changes to `GTK_EVENT_SEQUENCE_DENIED`. This way event coherence is preserved before event propagation is unstopped again.

Sequence states can't be changed freely, see `gestureSetSequenceState` to know about the possible lifetimes of a `EventSequence`.

## Touchpad gestures

On the platforms that support it, `Gesture` will handle transparently touchpad gesture events. The only precautions users of `Gesture` should do to enable this support are: * Enabling `EventMaskTouchpadGestureMask` on their `GdkWindows` * If the gesture has `PropagationPhaseNone`, ensuring events of type `EventTypeTouchpadSwipe` and `EventTypeTouchpadPinch` are handled by the `Gesture`

Synopsis

- newtype Gesture = Gesture (ManagedPtr Gesture)
- class (GObject o, IsDescendantOf Gesture o) => IsGesture o
- toGesture :: (MonadIO m, IsGesture o) => o -> m Gesture
- gestureGetBoundingBox :: (HasCallStack, MonadIO m, IsGesture a) => a -> m (Bool, Rectangle)
- gestureGetBoundingBoxCenter :: (HasCallStack, MonadIO m, IsGesture a) => a -> m (Bool, Double, Double)
- gestureGetDevice :: (HasCallStack, MonadIO m, IsGesture a) => a -> m (Maybe Device)
- gestureGetGroup :: (HasCallStack, MonadIO m, IsGesture a) => a -> m [Gesture]
- gestureGetLastEvent :: (HasCallStack, MonadIO m, IsGesture a) => a -> Maybe EventSequence -> m (Maybe Event)
- gestureGetLastUpdatedSequence :: (HasCallStack, MonadIO m, IsGesture a) => a -> m (Maybe EventSequence)
- gestureGetPoint :: (HasCallStack, MonadIO m, IsGesture a) => a -> Maybe EventSequence -> m (Bool, Double, Double)
- gestureGetSequenceState :: (HasCallStack, MonadIO m, IsGesture a) => a -> EventSequence -> m EventSequenceState
- gestureGetSequences :: (HasCallStack, MonadIO m, IsGesture a) => a -> m [EventSequence]
- gestureGetWindow :: (HasCallStack, MonadIO m, IsGesture a) => a -> m (Maybe Window)
- gestureGroup :: (HasCallStack, MonadIO m, IsGesture a, IsGesture b) => a -> b -> m ()
- gestureHandlesSequence :: (HasCallStack, MonadIO m, IsGesture a) => a -> Maybe EventSequence -> m Bool
- gestureIsActive :: (HasCallStack, MonadIO m, IsGesture a) => a -> m Bool
- gestureIsGroupedWith :: (HasCallStack, MonadIO m, IsGesture a, IsGesture b) => a -> b -> m Bool
- gestureIsRecognized :: (HasCallStack, MonadIO m, IsGesture a) => a -> m Bool
- gestureSetSequenceState :: (HasCallStack, MonadIO m, IsGesture a) => a -> EventSequence -> EventSequenceState -> m Bool
- gestureSetState :: (HasCallStack, MonadIO m, IsGesture a) => a -> EventSequenceState -> m Bool
- gestureSetWindow :: (HasCallStack, MonadIO m, IsGesture a, IsWindow b) => a -> Maybe b -> m ()
- gestureUngroup :: (HasCallStack, MonadIO m, IsGesture a) => a -> m ()
- constructGestureNPoints :: (IsGesture o, MonadIO m) => Word32 -> m (GValueConstruct o)
- getGestureNPoints :: (MonadIO m, IsGesture o) => o -> m Word32
- clearGestureWindow :: (MonadIO m, IsGesture o) => o -> m ()
- constructGestureWindow :: (IsGesture o, MonadIO m, IsWindow a) => a -> m (GValueConstruct o)
- getGestureWindow :: (MonadIO m, IsGesture o) => o -> m (Maybe Window)
- setGestureWindow :: (MonadIO m, IsGesture o, IsWindow a) => o -> a -> m ()
- type GestureBeginCallback = Maybe EventSequence -> IO ()
- afterGestureBegin :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureBeginCallback) -> m SignalHandlerId
- onGestureBegin :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureBeginCallback) -> m SignalHandlerId
- type GestureCancelCallback = Maybe EventSequence -> IO ()
- afterGestureCancel :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureCancelCallback) -> m SignalHandlerId
- onGestureCancel :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureCancelCallback) -> m SignalHandlerId
- type GestureEndCallback = Maybe EventSequence -> IO ()
- afterGestureEnd :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureEndCallback) -> m SignalHandlerId
- onGestureEnd :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureEndCallback) -> m SignalHandlerId
- type GestureSequenceStateChangedCallback = Maybe EventSequence -> EventSequenceState -> IO ()
- afterGestureSequenceStateChanged :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureSequenceStateChangedCallback) -> m SignalHandlerId
- onGestureSequenceStateChanged :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureSequenceStateChangedCallback) -> m SignalHandlerId
- type GestureUpdateCallback = Maybe EventSequence -> IO ()
- afterGestureUpdate :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureUpdateCallback) -> m SignalHandlerId
- onGestureUpdate :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureUpdateCallback) -> m SignalHandlerId

# Exported types

newtype Gesture Source #

Memory-managed wrapper type.

Constructors

Gesture (ManagedPtr Gesture) |

#### Instances

Instances details

Eq Gesture Source # |
Instance details Defined in GI.Gtk.Objects.Gesture Methods (==) :: Gesture -> Gesture -> Bool Source # (/=) :: Gesture -> Gesture -> Bool Source #
GObject Gesture Source # |
Instance details Defined in GI.Gtk.Objects.Gesture
ManagedPtrNewtype Gesture Source # |
Instance details Defined in GI.Gtk.Objects.Gesture Methods toManagedPtr :: Gesture -> ManagedPtr Gesture Source #
TypedObject Gesture Source # |
Instance details Defined in GI.Gtk.Objects.Gesture Methods glibType :: IO GType Source #
HasParentTypes Gesture Source # |
Instance details Defined in GI.Gtk.Objects.Gesture
IsGValue (Maybe Gesture) Source # | Convert `Gesture` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.Gesture Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Gesture -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Gesture) Source #
type ParentTypes Gesture Source # |
Instance details Defined in GI.Gtk.Objects.Gesture type ParentTypes Gesture = '[EventController, Object]

class (GObject o, IsDescendantOf Gesture o) => IsGesture o Source #

Type class for types which can be safely cast to `Gesture`, for instance with `toGesture`.

#### Instances

Instances details

(GObject o, IsDescendantOf Gesture o) => IsGesture o Source # |
Instance details Defined in GI.Gtk.Objects.Gesture

toGesture :: (MonadIO m, IsGesture o) => o -> m Gesture Source #

Cast to `Gesture`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, group, handleEvent, handlesSequence, isActive, isFloating, isGroupedWith, isRecognized, notify, notifyByPspec, ref, refSink, reset, runDispose, stealData, stealQdata, thawNotify, ungroup, unref, watchClosure.

#### Getters

getBoundingBox, getBoundingBoxCenter, getData, getDevice, getGroup, getLastEvent, getLastUpdatedSequence, getPoint, getPropagationPhase, getProperty, getQdata, getSequenceState, getSequences, getWidget, getWindow.

#### Setters

setData, setDataFull, setPropagationPhase, setProperty, setSequenceState, setState, setWindow.

## getBoundingBox

gestureGetBoundingBox Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m (Bool, Rectangle) | Returns: `True` if there are active touches, `False` otherwise

If there are touch sequences being currently handled by `gesture`, this function returns `True` and fills in `rect` with the bounding box containing all active touches. Otherwise, `False` will be returned.

Note: This function will yield unexpected results on touchpad gestures. Since there is no correlation between physical and pixel distances, these will look as if constrained in an infinitely small area, `rect` width and height will thus be 0 regardless of the number of touchpoints.

Since: 3.14

## getBoundingBoxCenter

gestureGetBoundingBoxCenter Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m (Bool, Double, Double) | Returns: `False` if no active touches are present, `True` otherwise

If there are touch sequences being currently handled by `gesture`, this function returns `True` and fills in `x` and `y` with the center of the bounding box containing all active touches. Otherwise, `False` will be returned.

Since: 3.14

## getDevice

gestureGetDevice Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m (Maybe Device) | Returns: a `Device`, or `Nothing`

Returns the master `Device` that is currently operating on `gesture`, or `Nothing` if the gesture is not being interacted.

Since: 3.14

## getGroup

gestureGetGroup Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m [Gesture] | Returns: The list of `GtkGestures`, free with `g_list_free()`

Returns all gestures in the group of `gesture`

Since: 3.14

## getLastEvent

gestureGetLastEvent Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> Maybe EventSequence | `sequence`: a `EventSequence`
-> m (Maybe Event) | Returns: The last event from `sequence`

Returns the last event that was processed for `sequence`.

Note that the returned pointer is only valid as long as the `sequence` is still interpreted by the `gesture`. If in doubt, you should make a copy of the event.

## getLastUpdatedSequence

gestureGetLastUpdatedSequence Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m (Maybe EventSequence) | Returns: The last updated sequence

Returns the `EventSequence` that was last updated on `gesture`.

Since: 3.14

## getPoint

gestureGetPoint Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> Maybe EventSequence | `sequence`: a `EventSequence`, or `Nothing` for pointer events
-> m (Bool, Double, Double) | Returns: `True` if `sequence` is currently interpreted

If `sequence` is currently being interpreted by `gesture`, this function returns `True` and fills in `x` and `y` with the last coordinates stored for that event sequence. The coordinates are always relative to the widget allocation.

Since: 3.14

## getSequenceState

gestureGetSequenceState Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> EventSequence | `sequence`: a `EventSequence`
-> m EventSequenceState | Returns: The sequence state in `gesture`

Returns the `sequence` state, as seen by `gesture`.

Since: 3.14

## getSequences

gestureGetSequences Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m [EventSequence] | Returns: A list of `GdkEventSequences`, the list elements are owned by GTK+ and must not be freed or modified, the list itself must be deleted through `g_list_free()`

Returns the list of `GdkEventSequences` currently being interpreted by `gesture`.

Since: 3.14

## getWindow

gestureGetWindow Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m (Maybe Window) | Returns: the user defined window, or `Nothing` if none

Returns the user-defined window that receives the events handled by `gesture`. See `gestureSetWindow` for more information.

Since: 3.14

## group

gestureGroup Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a, IsGesture b) |
=> a | `groupGesture`: `Gesture` to group `gesture` with
-> b | `gesture`: a `Gesture`
-> m () |

Adds `gesture` to the same group than `groupGesture`. Gestures are by default isolated in their own groups.

When gestures are grouped, the state of `GdkEventSequences` is kept in sync for all of those, so calling `gestureSetSequenceState`, on one will transfer the same value to the others.

Groups also perform an "implicit grabbing" of sequences, if a `EventSequence` state is set to `GTK_EVENT_SEQUENCE_CLAIMED` on one group, every other gesture group attached to the same `Widget` will switch the state for that sequence to `GTK_EVENT_SEQUENCE_DENIED`.

Since: 3.14

## handlesSequence

gestureHandlesSequence Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> Maybe EventSequence | `sequence`: a `EventSequence` or `Nothing`
-> m Bool | Returns: `True` if `gesture` is handling `sequence`, `False` otherwise

Returns `True` if `gesture` is currently handling events corresponding to `sequence`.

Since: 3.14

## isActive

gestureIsActive Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m Bool | Returns: `True` if gesture is active

Returns `True` if the gesture is currently active. A gesture is active meanwhile there are touch sequences interacting with it.

Since: 3.14

## isGroupedWith

gestureIsGroupedWith Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a, IsGesture b) |
=> a | `gesture`: a `Gesture`
-> b | `other`: another `Gesture`
-> m Bool | Returns: whether the gestures are grouped

Returns `True` if both gestures pertain to the same group.

Since: 3.14

## isRecognized

gestureIsRecognized Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m Bool | Returns: `True` if gesture is recognized

Returns `True` if the gesture is currently recognized. A gesture is recognized if there are as many interacting touch sequences as required by `gesture`, and `Gesture`::`check` returned `True` for the sequences being currently interpreted.

Since: 3.14

## setSequenceState

gestureSetSequenceState Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> EventSequence | `sequence`: a `EventSequence`
-> EventSequenceState | `state`: the sequence state
-> m Bool | Returns: `True` if `sequence` is handled by `gesture`, and the state is changed successfully

Sets the state of `sequence` in `gesture`. Sequences start in state `GTK_EVENT_SEQUENCE_NONE`, and whenever they change state, they can never go back to that state. Likewise, sequences in state `GTK_EVENT_SEQUENCE_DENIED` cannot turn back to a not denied state. With these rules, the lifetime of an event sequence is constrained to the next four:

- None
- None → Denied
- None → Claimed
- None → Claimed → Denied

Note: Due to event handling ordering, it may be unsafe to set the state on another gesture within a Gesture::begin signal handler, as the callback might be executed before the other gesture knows about the sequence. A safe way to perform this could be:

    static void
    first_gesture_begin_cb (GtkGesture       *first_gesture,
                            GdkEventSequence *sequence,
                            gpointer          user_data)
    {
      gtk_gesture_set_sequence_state (first_gesture, sequence, GTK_EVENT_SEQUENCE_CLAIMED);
      gtk_gesture_set_sequence_state (second_gesture, sequence, GTK_EVENT_SEQUENCE_DENIED);
    }

    static void
    second_gesture_begin_cb (GtkGesture       *second_gesture,
                             GdkEventSequence *sequence,
                             gpointer          user_data)
    {
      if (gtk_gesture_get_sequence_state (first_gesture, sequence) == GTK_EVENT_SEQUENCE_CLAIMED)
        gtk_gesture_set_sequence_state (second_gesture, sequence, GTK_EVENT_SEQUENCE_DENIED);
    }

If both gestures are in the same group, just set the state on the gesture emitting the event, the sequence will be already be initialized to the group's global state when the second gesture processes the event.

Since: 3.14

## setState

gestureSetState Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> EventSequenceState | `state`: the sequence state
-> m Bool | Returns: `True` if the state of at least one sequence was changed successfully

Sets the state of all sequences that `gesture` is currently interacting with. See `gestureSetSequenceState` for more details on sequence states.

Since: 3.14

## setWindow

gestureSetWindow Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a, IsWindow b) |
=> a | `gesture`: a `Gesture`
-> Maybe b | `window`: a `Window`, or `Nothing`
-> m () |

Sets a specific window to receive events about, so `gesture` will effectively handle only events targeting `window`, or a child of it. `window` must pertain to `eventControllerGetWidget`.

Since: 3.14

## ungroup

gestureUngroup Source #

Arguments

:: (HasCallStack, MonadIO m, IsGesture a) |
=> a | `gesture`: a `Gesture`
-> m () |

Separates `gesture` into an isolated group.

Since: 3.14

# Properties

## nPoints

The number of touch points that trigger recognition on this gesture,

Since: 3.14

constructGestureNPoints :: (IsGesture o, MonadIO m) => Word32 -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`n-points`” property. This is rarely needed directly, but it is used by `new`.

getGestureNPoints :: (MonadIO m, IsGesture o) => o -> m Word32 Source #

Get the value of the “`n-points`” property. When overloading is enabled, this is equivalent to

    get gesture #nPoints

## window

If non-`Nothing`, the gesture will only listen for events that happen on this `Window`, or a child of it.

Since: 3.14

clearGestureWindow :: (MonadIO m, IsGesture o) => o -> m () Source #

Set the value of the “`window`” property to `Nothing`. When overloading is enabled, this is equivalent to

    clear #window

constructGestureWindow :: (IsGesture o, MonadIO m, IsWindow a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`window`” property. This is rarely needed directly, but it is used by `new`.

getGestureWindow :: (MonadIO m, IsGesture o) => o -> m (Maybe Window) Source #

Get the value of the “`window`” property. When overloading is enabled, this is equivalent to

    get gesture #window

setGestureWindow :: (MonadIO m, IsGesture o, IsWindow a) => o -> a -> m () Source #

Set the value of the “`window`” property. When overloading is enabled, this is equivalent to

    set gesture [ #window := value ]

# Signals

## begin

type GestureBeginCallback Source #

Arguments

= Maybe EventSequence | `sequence`: the `EventSequence` that made the gesture to be recognized
-> IO () |

This signal is emitted when the gesture is recognized. This means the number of touch sequences matches Gesture:nPoints, and the `Gesture`::`check` handler(s) returned `TRUE`.

Note: These conditions may also happen when an extra touch (eg. a third touch on a 2-touches gesture) is lifted, in that situation `sequence` won't pertain to the current set of active touches, so don't rely on this being true.

Since: 3.14

afterGestureBegin :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureBeginCallback) -> m SignalHandlerId Source #

Connect a signal handler for the begin signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after gesture #begin callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onGestureBegin :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureBeginCallback) -> m SignalHandlerId Source #

Connect a signal handler for the begin signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on gesture #begin callback

## cancel

type GestureCancelCallback Source #

Arguments

= Maybe EventSequence | `sequence`: the `EventSequence` that was cancelled
-> IO () |

This signal is emitted whenever a sequence is cancelled. This usually happens on active touches when `eventControllerReset` is called on `gesture` (manually, due to grabs...), or the individual `sequence` was claimed by parent widgets' controllers (see `gestureSetSequenceState`).

`gesture` must forget everything about `sequence` as a reaction to this signal.

Since: 3.14

afterGestureCancel :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureCancelCallback) -> m SignalHandlerId Source #

Connect a signal handler for the cancel signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after gesture #cancel callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onGestureCancel :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureCancelCallback) -> m SignalHandlerId Source #

Connect a signal handler for the cancel signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on gesture #cancel callback

## end

type GestureEndCallback Source #

Arguments

= Maybe EventSequence | `sequence`: the `EventSequence` that made gesture recognition to finish
-> IO () |

This signal is emitted when `gesture` either stopped recognizing the event sequences as something to be handled (the `Gesture`::`check` handler returned `False`), or the number of touch sequences became higher or lower than Gesture:nPoints.

Note: `sequence` might not pertain to the group of sequences that were previously triggering recognition on `gesture` (ie. a just pressed touch sequence that exceeds Gesture:nPoints). This situation may be detected by checking through `gestureHandlesSequence`.

Since: 3.14

afterGestureEnd :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureEndCallback) -> m SignalHandlerId Source #

Connect a signal handler for the end signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after gesture #end callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onGestureEnd :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureEndCallback) -> m SignalHandlerId Source #

Connect a signal handler for the end signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on gesture #end callback

## sequenceStateChanged

type GestureSequenceStateChangedCallback Source #

Arguments

= Maybe EventSequence | `sequence`: the `EventSequence` that was cancelled
-> EventSequenceState | `state`: the new sequence state
-> IO () |

This signal is emitted whenever a sequence state changes. See `gestureSetSequenceState` to know more about the expectable sequence lifetimes.

Since: 3.14

afterGestureSequenceStateChanged :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureSequenceStateChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the sequenceStateChanged signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after gesture #sequenceStateChanged callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onGestureSequenceStateChanged :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureSequenceStateChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the sequenceStateChanged signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on gesture #sequenceStateChanged callback

## update

type GestureUpdateCallback Source #

Arguments

= Maybe EventSequence | `sequence`: the `EventSequence` that was updated
-> IO () |

This signal is emitted whenever an event is handled while the gesture is recognized. `sequence` is guaranteed to pertain to the set of active touches.

Since: 3.14

afterGestureUpdate :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureUpdateCallback) -> m SignalHandlerId Source #

Connect a signal handler for the update signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after gesture #update callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onGestureUpdate :: (IsGesture a, MonadIO m) => a -> ((?self :: a) => GestureUpdateCallback) -> m SignalHandlerId Source #

Connect a signal handler for the update signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on gesture #update callback